import { HTMLProjectionNode } from '../../projection/node/HTMLProjectionNode.js';

function useProjection(projectionId, _a, visualElement) {
    var _b;
    var layoutId = _a.layoutId, layout = _a.layout, drag = _a.drag;
    if (!visualElement || visualElement.projection)
        return;
    visualElement.projection = new HTMLProjectionNode(projectionId, visualElement.getLatestValues(), (_b = visualElement.parent) === null || _b === void 0 ? void 0 : _b.projection);
    visualElement.projection.setOptions({
        layoutId: layoutId,
        layout: layout,
        alwaysMeasureLayout: !!drag,
        visualElement: visualElement,
        onProjectionUpdate: function () { return visualElement.scheduleRender(); },
        /**
         * TODO: Update options in an effect. This could be tricky as it'll be too late
         * to update by the time layout animations run.
         * We also need to fix this safeToRemove by linking it up to the one returned by usePresence,
         * ensuring it gets called if there's no potential layout animations.
         *
         */
        // onExitComplete: () => this.safeToRemove(),
        animationType: typeof layout === "string" ? layout : "both",
    });
}

export { useProjection };
