import { convertBoundingBoxToBox, transformBoxPoints } from '../geometry/conversion.js';
import { createProjectionNode } from './create-projection-node.js';
import { DocumentProjectionNode } from './DocumentProjectionNode.js';
import { createProjectionId } from './id.js';

var rootProjectionNode = {
    current: undefined,
};
function measureViewportBox(instance, transformPoint) {
    return convertBoundingBoxToBox(transformBoxPoints(instance.getBoundingClientRect(), transformPoint));
}
var HTMLProjectionNode = createProjectionNode({
    measureScroll: function (instance) { return ({
        x: instance.scrollLeft,
        y: instance.scrollTop,
    }); },
    defaultParent: function () {
        if (!rootProjectionNode.current) {
            var documentNode = new DocumentProjectionNode(createProjectionId(), {});
            documentNode.mount(window);
            documentNode.setOptions({
                shouldMeasureScroll: true,
            });
            rootProjectionNode.current = documentNode;
        }
        return rootProjectionNode.current;
    },
    resetTransform: function (instance) { return (instance.style.transform = "none"); },
});

export { HTMLProjectionNode, measureViewportBox, rootProjectionNode };
