import { TransformPoint } from "../geometry/types";
import { IProjectionNode } from "./types";
export declare const rootProjectionNode: {
    current: IProjectionNode | undefined;
};
export declare function measureViewportBox(instance: HTMLElement, transformPoint?: TransformPoint): import("../geometry/types").Box;
export declare const HTMLProjectionNode: {
    new (id: number, latestValues: import("../../render/types").ResolvedValues, parent?: IProjectionNode<unknown> | undefined): {
        id: number;
        instance: HTMLElement;
        root: IProjectionNode<unknown>;
        parent?: IProjectionNode<unknown> | undefined;
        path: IProjectionNode<unknown>[];
        children: Set<IProjectionNode<unknown>>;
        options: import("./types").ProjectionNodeOptions;
        snapshot: import("./types").Snapshot | undefined;
        layout: import("../geometry/types").Box | undefined;
        layoutCorrected: import("../geometry/types").Box;
        scroll?: import("../geometry/types").Point | undefined;
        isLayoutDirty: boolean;
        updateBlocked: boolean;
        isUpdating: boolean;
        shouldResetTransform: boolean;
        treeScale: import("../geometry/types").Point;
        targetDelta?: import("../geometry/types").Delta | undefined;
        projectionDelta?: import("../geometry/types").Delta | undefined;
        projectionDeltaWithTransform?: import("../geometry/types").Delta | undefined;
        lead?: IProjectionNode<unknown> | undefined;
        target?: import("../geometry/types").Box | undefined;
        targetWithTransforms?: import("../geometry/types").Box | undefined;
        latestValues: import("../../render/types").ResolvedValues;
        layoutWillUpdateListeners?: import("../../utils/subscription-manager").SubscriptionManager<VoidFunction> | undefined;
        layoutDidUpdateListeners?: import("../../utils/subscription-manager").SubscriptionManager<import("./types").LayoutUpdateHandler> | undefined;
        layoutMeasureListeners?: import("../../utils/subscription-manager").SubscriptionManager<VoidFunction> | undefined;
        potentialNodes: Map<number, IProjectionNode<unknown>>;
        registerPotentialNode(id: number, node: IProjectionNode<unknown>): void;
        mount(instance: HTMLElement, isLayoutDirty?: boolean): void;
        hasPendingLead(layoutId: string): boolean;
        unmount(): void;
        blockUpdate(): void;
        unblockUpdate(): void;
        startUpdate(): void;
        willUpdate(shouldNotifyListeners?: boolean): void;
        didUpdate(): void;
        scheduleUpdateProjection(): void;
        updateProjection: () => void;
        updateSnapshot(): void;
        updateLayout(): void;
        updateScroll(): void;
        resetTransform(): void;
        measure(): import("../geometry/types").Box;
        removeElementScroll(box: import("../geometry/types").Box): import("../geometry/types").Box;
        removeTransform(box: import("../geometry/types").Box): import("../geometry/types").Box;
        setTargetDelta(delta: import("../geometry/types").Delta): void;
        setOptions(options: import("./types").ProjectionNodeOptions): void;
        resolveTargetDelta(): void;
        calcProjection(): void;
        isVisible: boolean;
        hide(): void;
        show(): void;
        scheduleRender(): void;
        animationProgress: number;
        animationValues?: import("../../render/types").ResolvedValues | undefined;
        currentAnimation: import("../..").AnimationPlaybackControls;
        mixTargetDelta: (progress: number) => void;
        setAnimationOrigin(delta: import("../geometry/types").Delta): void;
        startAnimation(options: import("../..").AnimationOptions<number>): void;
        applyTransformsToTarget(): void;
        onLayoutWillUpdate(handler: VoidFunction): () => void;
        onLayoutDidUpdate(handler: (data: import("./types").LayoutUpdateData) => void): () => void;
        onLayoutMeasure(handler: VoidFunction): () => void;
        sharedNodes: Map<string, import("../shared/stack").NodeStack>;
        registerSharedNode(layoutId: string, node: IProjectionNode<unknown>): void;
        isLead(): boolean;
        getLead(): IProjectionNode<unknown> | any;
        getStack(): import("../shared/stack").NodeStack | undefined;
        promote(): void;
        resetRotation(): void;
        getProjectionStyles(): import("../../render/types").ResolvedValues;
    };
};
